//+------------------------------------------------------------------+
//|                                                  SQ9 (Price).mq4 |
//|                                  Copyright  2006, Matt Trigwell |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Matt Trigwell"
#property link      "m.trigwell@gmail.com"

#property indicator_chart_window


double    line_spacing_multiplier=1000000;

extern int        levels__to=360;
extern int        lines_every=180;
extern double     factorNumber=1;

extern color     line_Color=FireBrick;
extern int       line_Style_choose_from_0_to_4=0;
extern int       font_size=9;


bool      is_this_the_HIGH_price=true;


int init()
{
   return(0);
}

int deinit()
{
   double AngleIndex1b=0;
   string AngleName1b="";


   for(AngleIndex1b=0;AngleIndex1b<=levels__to;AngleIndex1b=AngleIndex1b+lines_every)
   {
      AngleName1b = "Angle1b_" + AngleIndex1b;
      ObjectDelete(AngleName1b + " Label");
      ObjectDelete(AngleName1b + " Line");
   }

   
   return(0);
}

int start()
{
double    the_High_or_Low_Price=0;   
   double AngleIndex1b=0;
   string AngleName1b="";
   double FactorIndex=0;
   double AnglePrice1bLevel=0;
   int Index=0;
   string strLabel="";
   
if(ObjectFind("9")!=-1)
   {

   the_High_or_Low_Price = ObjectGet("9", OBJPROP_PRICE1); 

   }
   
                  
 ////////////////////////////////////////////////////////////////  
   
   
 



   
              
   for(AngleIndex1b=0;AngleIndex1b<=levels__to;AngleIndex1b=AngleIndex1b+lines_every)
   {
      AnglePrice1bLevel = CalculateSquare(FactorIndex,the_High_or_Low_Price);
      
      //Trim Zero's
      if(Index==1)
      {
         strLabel = DoubleToStr(AngleIndex1b,1);
      }
      else
      {
         strLabel = DoubleToStr(AngleIndex1b,0);
      }
      
      AngleName1b = "Angle1b_" + AngleIndex1b;
      
      

      if(ObjectFind(AngleName1b + " Line") != 0)
      {
         ObjectCreate(AngleName1b + " Line", OBJ_HLINE, 0, Time[40], AnglePrice1bLevel);
         ObjectSet(AngleName1b + " Line", OBJPROP_STYLE, line_Style_choose_from_0_to_4);
         
         if(MathMod(Index,2) == 0)
         {
            ObjectSet(AngleName1b + " Line", OBJPROP_COLOR, line_Color);
         }
         else
         {
             ObjectSet(AngleName1b + " Line", OBJPROP_COLOR, line_Color);
         }
      }
      else
      {
         ObjectMove(AngleName1b + " Line", 0, Time[40], AnglePrice1bLevel);
      }
   
      if(ObjectFind(AngleName1b + " Label") != 0)
      {
         ObjectCreate(AngleName1b + " Label", OBJ_TEXT, 0, Time[30], AnglePrice1bLevel);
         
         if(MathMod(Index,2) == 0)
         {
            ObjectSetText(AngleName1b + " Label", strLabel + "", font_size, "Arial", line_Color);
            
         }
         else
         {
             ObjectSetText(AngleName1b + " Label", strLabel + "", font_size, "Arial", line_Color);
         }  

      }
      else
      {
         ObjectMove(AngleName1b + " Label", 0, Time[20], AnglePrice1bLevel);
      }
      
      FactorIndex = FactorIndex + factorNumber;
      Index = Index + 1;
   }

   return(0);
}






double CalculateSquare(double Factor, double Price)
{
   double AnglePrice1b=0;



  if(Price > 0)
   {
   
      if(StringFind(Symbol(),"JPY",0) == -1)
      {
         Price = Price * line_spacing_multiplier;
      }
      else
      {
         Price = Price * line_spacing_multiplier;
         Price = Price  / 100;
      }
            
      if(is_this_the_HIGH_price==false)
      {
         AnglePrice1b = MathPow(MathSqrt(Price) + Factor,2);
      }
      else
      {
         AnglePrice1b = MathPow(MathSqrt(Price) - Factor,2);
      }
   
      if(StringFind(Symbol(),"JPY",0) == -1)
      {
         AnglePrice1b = AnglePrice1b / line_spacing_multiplier;
      }
      else
      {
         AnglePrice1b = AnglePrice1b / line_spacing_multiplier;
         AnglePrice1b = AnglePrice1b  * 100;
      }
   
   }
   
   return(AnglePrice1b);

 
} 