//+------------------------------------------------------------------+
//|                                                  SQ9 (Price).mq4 |
//|                                  Copyright  2006, Matt Trigwell |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Matt Trigwell"
#property link      "m.trigwell@gmail.com"

#property indicator_chart_window


double    line_spacing_multiplier=100000;

extern int        levels__to=360;
extern int        lines_every=180;
extern double     factorNumber=1;

extern color     line_Color=Green;
extern int       line_Style_choose_from_0_to_4=0;
extern int       font_size=9;


bool      is_this_the_HIGH_price=true;


int init()
{
   return(0);
}

int deinit()
{
   double AngleIndex2b=0;
   string AngleName2b="";


   for(AngleIndex2b=0;AngleIndex2b<=levels__to;AngleIndex2b=AngleIndex2b+lines_every)
   {
      AngleName2b = "Angle2b_" + AngleIndex2b;
      ObjectDelete(AngleName2b + " Label");
      ObjectDelete(AngleName2b + " Line");
   }

   
   return(0);
}

int start()
{
double    the_High_or_Low_Price=0;   
   double AngleIndex2b=0;
   string AngleName2b="";
   double FactorIndex=0;
   double AnglePrice2bLevel=0;
   int Index=0;
   string strLabel="";
   
if(ObjectFind("9")!=-1)
   {

   the_High_or_Low_Price = ObjectGet("9", OBJPROP_PRICE1); 

   }
   
                  
 ////////////////////////////////////////////////////////////////  
   
   
 



   
              
   for(AngleIndex2b=0;AngleIndex2b<=levels__to;AngleIndex2b=AngleIndex2b+lines_every)
   {
      AnglePrice2bLevel = CalculateSquare(FactorIndex,the_High_or_Low_Price);
      
      //Trim Zero's
      if(Index==1)
      {
         strLabel = DoubleToStr(AngleIndex2b,1);
      }
      else
      {
         strLabel = DoubleToStr(AngleIndex2b,0);
      }
      
      AngleName2b = "Angle2b_" + AngleIndex2b;
      
      

      if(ObjectFind(AngleName2b + " Line") != 0)
      {
         ObjectCreate(AngleName2b + " Line", OBJ_HLINE, 0, Time[40], AnglePrice2bLevel);
         ObjectSet(AngleName2b + " Line", OBJPROP_STYLE, line_Style_choose_from_0_to_4);
         
         if(MathMod(Index,2) == 0)
         {
            ObjectSet(AngleName2b + " Line", OBJPROP_COLOR, line_Color);
         }
         else
         {
             ObjectSet(AngleName2b + " Line", OBJPROP_COLOR, line_Color);
         }
      }
      else
      {
         ObjectMove(AngleName2b + " Line", 0, Time[40], AnglePrice2bLevel);
      }
   
      if(ObjectFind(AngleName2b + " Label") != 0)
      {
         ObjectCreate(AngleName2b + " Label", OBJ_TEXT, 0, Time[30], AnglePrice2bLevel);
         
         if(MathMod(Index,2) == 0)
         {
            ObjectSetText(AngleName2b + " Label", strLabel + "", font_size, "Arial", line_Color);
            
         }
         else
         {
             ObjectSetText(AngleName2b + " Label", strLabel + "", font_size, "Arial", line_Color);
         }  

      }
      else
      {
         ObjectMove(AngleName2b + " Label", 0, Time[20], AnglePrice2bLevel);
      }
      
      FactorIndex = FactorIndex + factorNumber;
      Index = Index + 1;
   }

   return(0);
}






double CalculateSquare(double Factor, double Price)
{
   double AnglePrice2b=0;



  if(Price > 0)
   {
   
      if(StringFind(Symbol(),"JPY",0) == -1)
      {
         Price = Price * line_spacing_multiplier;
      }
      else
      {
         Price = Price * line_spacing_multiplier;
         Price = Price  / 100;
      }
            
      if(is_this_the_HIGH_price==false)
      {
         AnglePrice2b = MathPow(MathSqrt(Price) + Factor,2);
      }
      else
      {
         AnglePrice2b = MathPow(MathSqrt(Price) - Factor,2);
      }
   
      if(StringFind(Symbol(),"JPY",0) == -1)
      {
         AnglePrice2b = AnglePrice2b / line_spacing_multiplier;
      }
      else
      {
         AnglePrice2b = AnglePrice2b / line_spacing_multiplier;
         AnglePrice2b = AnglePrice2b  * 100;
      }
   
   }
   
   return(AnglePrice2b);

 
} 