//+------------------------------------------------------------------+
//|                                                  SQ9 (Price).mq4 |
//|                                  Copyright  2006, Matt Trigwell |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Matt Trigwell"
#property link      "m.trigwell@gmail.com"

#property indicator_chart_window


double    line_spacing_multiplier=10000;

extern int        levels__to=360;
extern int        lines_every=180;
extern double     factorNumber=1;

extern color     line_Color=Magenta;
extern int       line_Style_choose_from_0_to_4=0;
extern int       font_size=9;


bool      is_this_the_HIGH_price=false;


int init()
{
   return(0);
}

int deinit()
{
   double AngleIndex3a=0;
   string AngleName3a="";


   for(AngleIndex3a=0;AngleIndex3a<=levels__to;AngleIndex3a=AngleIndex3a+lines_every)
   {
      AngleName3a = "Angle3a_" + AngleIndex3a;
      ObjectDelete(AngleName3a + " Label");
      ObjectDelete(AngleName3a + " Line");
   }

   
   return(0);
}

int start()
{
double    the_High_or_Low_Price=0;   
   double AngleIndex3a=0;
   string AngleName3a="";
   double FactorIndex=0;
   double AnglePrice3aLevel=0;
   int Index=0;
   string strLabel="";
   
if(ObjectFind("9")!=-1)
   {

   the_High_or_Low_Price = ObjectGet("9", OBJPROP_PRICE1); 

   }
   
                  
 ////////////////////////////////////////////////////////////////  
   
   
   



   
              
   for(AngleIndex3a=0;AngleIndex3a<=levels__to;AngleIndex3a=AngleIndex3a+lines_every)
   {
      AnglePrice3aLevel = CalculateSquare(FactorIndex,the_High_or_Low_Price);
      
      //Trim Zero's
      if(Index==1)
      {
         strLabel = DoubleToStr(AngleIndex3a,1);
      }
      else
      {
         strLabel = DoubleToStr(AngleIndex3a,0);
      }
      
      AngleName3a = "Angle3a_" + AngleIndex3a;
      
      

      if(ObjectFind(AngleName3a + " Line") != 0)
      {
         ObjectCreate(AngleName3a + " Line", OBJ_HLINE, 0, Time[40], AnglePrice3aLevel);
         ObjectSet(AngleName3a + " Line", OBJPROP_STYLE, line_Style_choose_from_0_to_4);
         
         if(MathMod(Index,2) == 0)
         {
            ObjectSet(AngleName3a + " Line", OBJPROP_COLOR, line_Color);
         }
         else
         {
             ObjectSet(AngleName3a + " Line", OBJPROP_COLOR, line_Color);
         }
      }
      else
      {
         ObjectMove(AngleName3a + " Line", 0, Time[40], AnglePrice3aLevel);
      }
   
      if(ObjectFind(AngleName3a + " Label") != 0)
      {
         ObjectCreate(AngleName3a + " Label", OBJ_TEXT, 0, Time[30], AnglePrice3aLevel);
         
         if(MathMod(Index,2) == 0)
         {
            ObjectSetText(AngleName3a + " Label", strLabel + "", font_size, "Arial", line_Color);
            
         }
         else
         {
             ObjectSetText(AngleName3a + " Label", strLabel + "", font_size, "Arial", line_Color);
         }  

      }
      else
      {
         ObjectMove(AngleName3a + " Label", 0, Time[20], AnglePrice3aLevel);
      }
      
      FactorIndex = FactorIndex + factorNumber;
      Index = Index + 1;
   }

   return(0);
}






double CalculateSquare(double Factor, double Price)
{
   double AnglePrice3a=0;



  if(Price > 0)
   {
   
      if(StringFind(Symbol(),"JPY",0) == -1)
      {
         Price = Price * line_spacing_multiplier;
      }
      else
      {
         Price = Price * line_spacing_multiplier;
         Price = Price  / 100;
      }
            
      if(is_this_the_HIGH_price==false)
      {
         AnglePrice3a = MathPow(MathSqrt(Price) + Factor,2);
      }
      else
      {
         AnglePrice3a = MathPow(MathSqrt(Price) - Factor,2);
      }
   
      if(StringFind(Symbol(),"JPY",0) == -1)
      {
         AnglePrice3a = AnglePrice3a / line_spacing_multiplier;
      }
      else
      {
         AnglePrice3a = AnglePrice3a / line_spacing_multiplier;
         AnglePrice3a = AnglePrice3a  * 100;
      }
   
   }
   
   return(AnglePrice3a);

 
} 