//+------------------------------------------------------------------+
//|                                                  SQ9 (Price).mq4 |
//|                                  Copyright  2006, Matt Trigwell |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Matt Trigwell"
#property link      "m.trigwell@gmail.com"

#property indicator_chart_window


double    line_spacing_multiplier=1000;

extern int        levels__to=360;
extern int        lines_every=180;
extern double     factorNumber=1;

extern color     line_Color=Yellow;
extern int       line_Style_choose_from_0_to_4=0;
extern int       font_size=9;


bool      is_this_the_HIGH_price=true;


int init()
{
   return(0);
}

int deinit()
{
   double AngleIndex4b=0;
   string AngleName4b="";


   for(AngleIndex4b=0;AngleIndex4b<=levels__to;AngleIndex4b=AngleIndex4b+lines_every)
   {
      AngleName4b = "Angle4b_" + AngleIndex4b;
      ObjectDelete(AngleName4b + " Label");
      ObjectDelete(AngleName4b + " Line");
   }

   
   return(0);
}

int start()
{
double    the_High_or_Low_Price=0;   
   double AngleIndex4b=0;
   string AngleName4b="";
   double FactorIndex=0;
   double AnglePrice4bLevel=0;
   int Index=0;
   string strLabel="";
   
if(ObjectFind("9")!=-1)
   {

   the_High_or_Low_Price = ObjectGet("9", OBJPROP_PRICE1); 

   }
   
                  
 ////////////////////////////////////////////////////////////////  
   
   
 



   
              
   for(AngleIndex4b=0;AngleIndex4b<=levels__to;AngleIndex4b=AngleIndex4b+lines_every)
   {
      AnglePrice4bLevel = CalculateSquare(FactorIndex,the_High_or_Low_Price);
      
      //Trim Zero's
      if(Index==1)
      {
         strLabel = DoubleToStr(AngleIndex4b,1);
      }
      else
      {
         strLabel = DoubleToStr(AngleIndex4b,0);
      }
      
      AngleName4b = "Angle4b_" + AngleIndex4b;
      
      

      if(ObjectFind(AngleName4b + " Line") != 0)
      {
         ObjectCreate(AngleName4b + " Line", OBJ_HLINE, 0, Time[40], AnglePrice4bLevel);
         ObjectSet(AngleName4b + " Line", OBJPROP_STYLE, line_Style_choose_from_0_to_4);
         
         if(MathMod(Index,2) == 0)
         {
            ObjectSet(AngleName4b + " Line", OBJPROP_COLOR, line_Color);
         }
         else
         {
             ObjectSet(AngleName4b + " Line", OBJPROP_COLOR, line_Color);
         }
      }
      else
      {
         ObjectMove(AngleName4b + " Line", 0, Time[40], AnglePrice4bLevel);
      }
   
      if(ObjectFind(AngleName4b + " Label") != 0)
      {
         ObjectCreate(AngleName4b + " Label", OBJ_TEXT, 0, Time[30], AnglePrice4bLevel);
         
         if(MathMod(Index,2) == 0)
         {
            ObjectSetText(AngleName4b + " Label", strLabel + "", font_size, "Arial", line_Color);
            
         }
         else
         {
             ObjectSetText(AngleName4b + " Label", strLabel + "", font_size, "Arial", line_Color);
         }  

      }
      else
      {
         ObjectMove(AngleName4b + " Label", 0, Time[20], AnglePrice4bLevel);
      }
      
      FactorIndex = FactorIndex + factorNumber;
      Index = Index + 1;
   }

   return(0);
}






double CalculateSquare(double Factor, double Price)
{
   double AnglePrice4b=0;



  if(Price > 0)
   {
   
      if(StringFind(Symbol(),"JPY",0) == -1)
      {
         Price = Price * line_spacing_multiplier;
      }
      else
      {
         Price = Price * line_spacing_multiplier;
         Price = Price  / 100;
      }
            
      if(is_this_the_HIGH_price==false)
      {
         AnglePrice4b = MathPow(MathSqrt(Price) + Factor,2);
      }
      else
      {
         AnglePrice4b = MathPow(MathSqrt(Price) - Factor,2);
      }
   
      if(StringFind(Symbol(),"JPY",0) == -1)
      {
         AnglePrice4b = AnglePrice4b / line_spacing_multiplier;
      }
      else
      {
         AnglePrice4b = AnglePrice4b / line_spacing_multiplier;
         AnglePrice4b = AnglePrice4b  * 100;
      }
   
   }
   
   return(AnglePrice4b);

 
} 