//+------------------------------------------------------------------+
//|                                                  SQ9 (Price).mq4 |
//|                                  Copyright  2006, Matt Trigwell |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Matt Trigwell"
#property link      "m.trigwell@gmail.com"

#property indicator_chart_window


double    line_spacing_multiplier=100;

extern int        levels__to=360;
extern int        lines_every=180;
extern double     factorNumber=1;

extern color     line_Color=White;
extern int       line_Style_choose_from_0_to_4=0;
extern int       font_size=9;


bool      is_this_the_HIGH_price=true;


int init()
{
   return(0);
}

int deinit()
{
   double AngleIndex5b=0;
   string AngleName5b="";


   for(AngleIndex5b=0;AngleIndex5b<=levels__to;AngleIndex5b=AngleIndex5b+lines_every)
   {
      AngleName5b = "Angle5b_" + AngleIndex5b;
      ObjectDelete(AngleName5b + " Label");
      ObjectDelete(AngleName5b + " Line");
   }

   
   return(0);
}

int start()
{
double    the_High_or_Low_Price=0;   
   double AngleIndex5b=0;
   string AngleName5b="";
   double FactorIndex=0;
   double AnglePrice5bLevel=0;
   int Index=0;
   string strLabel="";
   
if(ObjectFind("9")!=-1)
   {

   the_High_or_Low_Price = ObjectGet("9", OBJPROP_PRICE1); 

   }
   
                  
 ////////////////////////////////////////////////////////////////  
   
   
 



   
              
   for(AngleIndex5b=0;AngleIndex5b<=levels__to;AngleIndex5b=AngleIndex5b+lines_every)
   {
      AnglePrice5bLevel = CalculateSquare(FactorIndex,the_High_or_Low_Price);
      
      //Trim Zero's
      if(Index==1)
      {
         strLabel = DoubleToStr(AngleIndex5b,1);
      }
      else
      {
         strLabel = DoubleToStr(AngleIndex5b,0);
      }
      
      AngleName5b = "Angle5b_" + AngleIndex5b;
      
      

      if(ObjectFind(AngleName5b + " Line") != 0)
      {
         ObjectCreate(AngleName5b + " Line", OBJ_HLINE, 0, Time[40], AnglePrice5bLevel);
         ObjectSet(AngleName5b + " Line", OBJPROP_STYLE, line_Style_choose_from_0_to_4);
         
         if(MathMod(Index,2) == 0)
         {
            ObjectSet(AngleName5b + " Line", OBJPROP_COLOR, line_Color);
         }
         else
         {
             ObjectSet(AngleName5b + " Line", OBJPROP_COLOR, line_Color);
         }
      }
      else
      {
         ObjectMove(AngleName5b + " Line", 0, Time[40], AnglePrice5bLevel);
      }
   
      if(ObjectFind(AngleName5b + " Label") != 0)
      {
         ObjectCreate(AngleName5b + " Label", OBJ_TEXT, 0, Time[30], AnglePrice5bLevel);
         
         if(MathMod(Index,2) == 0)
         {
            ObjectSetText(AngleName5b + " Label", strLabel + "", font_size, "Arial", line_Color);
            
         }
         else
         {
             ObjectSetText(AngleName5b + " Label", strLabel + "", font_size, "Arial", line_Color);
         }  

      }
      else
      {
         ObjectMove(AngleName5b + " Label", 0, Time[20], AnglePrice5bLevel);
      }
      
      FactorIndex = FactorIndex + factorNumber;
      Index = Index + 1;
   }

   return(0);
}






double CalculateSquare(double Factor, double Price)
{
   double AnglePrice5b=0;



  if(Price > 0)
   {
   
      if(StringFind(Symbol(),"JPY",0) == -1)
      {
         Price = Price * line_spacing_multiplier;
      }
      else
      {
         Price = Price * line_spacing_multiplier;
         Price = Price  / 100;
      }
            
      if(is_this_the_HIGH_price==false)
      {
         AnglePrice5b = MathPow(MathSqrt(Price) + Factor,2);
      }
      else
      {
         AnglePrice5b = MathPow(MathSqrt(Price) - Factor,2);
      }
   
      if(StringFind(Symbol(),"JPY",0) == -1)
      {
         AnglePrice5b = AnglePrice5b / line_spacing_multiplier;
      }
      else
      {
         AnglePrice5b = AnglePrice5b / line_spacing_multiplier;
         AnglePrice5b = AnglePrice5b  * 100;
      }
   
   }
   
   return(AnglePrice5b);

 
} 