//+------------------------------------------------------------------+
//|                                                  SQ9 (Price).mq4 |
//|                                  Copyright  2006, Matt Trigwell |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Matt Trigwell"
#property link      "m.trigwell@gmail.com"

#property indicator_chart_window


double    line_spacing_multiplier=10;

extern int        levels__to=360;
extern int        lines_every=180;
extern double     factorNumber=1;

extern color     line_Color=Gold;
extern int       line_Style_choose_from_0_to_4=0;
extern int       font_size=9;


bool      is_this_the_HIGH_price=false;


int init()
{
   return(0);
}

int deinit()
{
   double AngleIndex6a=0;
   string AngleName6a="";


   for(AngleIndex6a=0;AngleIndex6a<=levels__to;AngleIndex6a=AngleIndex6a+lines_every)
   {
      AngleName6a = "Angle6a_" + AngleIndex6a;
      ObjectDelete(AngleName6a + " Label");
      ObjectDelete(AngleName6a + " Line");
   }

   
   return(0);
}

int start()
{
double    the_High_or_Low_Price=0;   
   double AngleIndex6a=0;
   string AngleName6a="";
   double FactorIndex=0;
   double AnglePrice6aLevel=0;
   int Index=0;
   string strLabel="";
   
if(ObjectFind("9")!=-1)
   {

   the_High_or_Low_Price = ObjectGet("9", OBJPROP_PRICE1); 

   }
   
                  
 ////////////////////////////////////////////////////////////////  
   
   
   



   
              
   for(AngleIndex6a=0;AngleIndex6a<=levels__to;AngleIndex6a=AngleIndex6a+lines_every)
   {
      AnglePrice6aLevel = CalculateSquare(FactorIndex,the_High_or_Low_Price);
      
      //Trim Zero's
      if(Index==1)
      {
         strLabel = DoubleToStr(AngleIndex6a,1);
      }
      else
      {
         strLabel = DoubleToStr(AngleIndex6a,0);
      }
      
      AngleName6a = "Angle6a_" + AngleIndex6a;
      
      

      if(ObjectFind(AngleName6a + " Line") != 0)
      {
         ObjectCreate(AngleName6a + " Line", OBJ_HLINE, 0, Time[40], AnglePrice6aLevel);
         ObjectSet(AngleName6a + " Line", OBJPROP_STYLE, line_Style_choose_from_0_to_4);
         
         if(MathMod(Index,2) == 0)
         {
            ObjectSet(AngleName6a + " Line", OBJPROP_COLOR, line_Color);
         }
         else
         {
             ObjectSet(AngleName6a + " Line", OBJPROP_COLOR, line_Color);
         }
      }
      else
      {
         ObjectMove(AngleName6a + " Line", 0, Time[40], AnglePrice6aLevel);
      }
   
      if(ObjectFind(AngleName6a + " Label") != 0)
      {
         ObjectCreate(AngleName6a + " Label", OBJ_TEXT, 0, Time[30], AnglePrice6aLevel);
         
         if(MathMod(Index,2) == 0)
         {
            ObjectSetText(AngleName6a + " Label", strLabel + "", font_size, "Arial", line_Color);
            
         }
         else
         {
             ObjectSetText(AngleName6a + " Label", strLabel + "", font_size, "Arial", line_Color);
         }  

      }
      else
      {
         ObjectMove(AngleName6a + " Label", 0, Time[20], AnglePrice6aLevel);
      }
      
      FactorIndex = FactorIndex + factorNumber;
      Index = Index + 1;
   }

   return(0);
}






double CalculateSquare(double Factor, double Price)
{
   double AnglePrice6a=0;



  if(Price > 0)
   {
   
      if(StringFind(Symbol(),"JPY",0) == -1)
      {
         Price = Price * line_spacing_multiplier;
      }
      else
      {
         Price = Price * line_spacing_multiplier;
         Price = Price  / 100;
      }
            
      if(is_this_the_HIGH_price==false)
      {
         AnglePrice6a = MathPow(MathSqrt(Price) + Factor,2);
      }
      else
      {
         AnglePrice6a = MathPow(MathSqrt(Price) - Factor,2);
      }
   
      if(StringFind(Symbol(),"JPY",0) == -1)
      {
         AnglePrice6a = AnglePrice6a / line_spacing_multiplier;
      }
      else
      {
         AnglePrice6a = AnglePrice6a / line_spacing_multiplier;
         AnglePrice6a = AnglePrice6a  * 100;
      }
   
   }
   
   return(AnglePrice6a);

 
} 