//+------------------------------------------------------------------+
//|                                                  SQ9 (Price).mq4 |
//|                                  Copyright  2006, Matt Trigwell |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Matt Trigwell"
#property link      "m.trigwell@gmail.com"

#property indicator_chart_window


double    line_spacing_multiplier=1000000;

extern int        levels__to=360;
extern int        lines_every=180;
extern double     factorNumber=1;

extern color     line_Color=FireBrick;
extern int       line_Style_choose_from_0_to_4=0;
extern int       font_size=9;


bool      is_this_the_HIGH_price=false;


int init()
{
   return(0);
}

int deinit()
{
   double AngleIndex1a=0;
   string AngleName1a="";


   for(AngleIndex1a=0;AngleIndex1a<=levels__to;AngleIndex1a=AngleIndex1a+lines_every)
   {
      AngleName1a = "Angle1a_" + AngleIndex1a;
      ObjectDelete(AngleName1a + " Label");
      ObjectDelete(AngleName1a + " Line");
   }

   
   return(0);
}

int start()
{
double    the_High_or_Low_Price=0;   
   double AngleIndex1a=0;
   string AngleName1a="";
   double FactorIndex=0;
   double AnglePrice1aLevel=0;
   int Index=0;
   string strLabel="";
   
if(ObjectFind("9")!=-1)
   {

   the_High_or_Low_Price = ObjectGet("9", OBJPROP_PRICE1); 

   }
   
                  
 ////////////////////////////////////////////////////////////////  
   
   
   



   
              
   for(AngleIndex1a=0;AngleIndex1a<=levels__to;AngleIndex1a=AngleIndex1a+lines_every)
   {
      AnglePrice1aLevel = CalculateSquare(FactorIndex,the_High_or_Low_Price);
      
      //Trim Zero's
      if(Index==1)
      {
         strLabel = DoubleToStr(AngleIndex1a,1);
      }
      else
      {
         strLabel = DoubleToStr(AngleIndex1a,0);
      }
      
      AngleName1a = "Angle1a_" + AngleIndex1a;
      
      

      if(ObjectFind(AngleName1a + " Line") != 0)
      {
         ObjectCreate(AngleName1a + " Line", OBJ_HLINE, 0, Time[40], AnglePrice1aLevel);
         ObjectSet(AngleName1a + " Line", OBJPROP_STYLE, line_Style_choose_from_0_to_4);
         
         if(MathMod(Index,2) == 0)
         {
            ObjectSet(AngleName1a + " Line", OBJPROP_COLOR, line_Color);
         }
         else
         {
             ObjectSet(AngleName1a + " Line", OBJPROP_COLOR, line_Color);
         }
      }
      else
      {
         ObjectMove(AngleName1a + " Line", 0, Time[40], AnglePrice1aLevel);
      }
   
      if(ObjectFind(AngleName1a + " Label") != 0)
      {
         ObjectCreate(AngleName1a + " Label", OBJ_TEXT, 0, Time[30], AnglePrice1aLevel);
         
         if(MathMod(Index,2) == 0)
         {
            ObjectSetText(AngleName1a + " Label", strLabel + "", font_size, "Arial", line_Color);
            
         }
         else
         {
             ObjectSetText(AngleName1a + " Label", strLabel + "", font_size, "Arial", line_Color);
         }  

      }
      else
      {
         ObjectMove(AngleName1a + " Label", 0, Time[20], AnglePrice1aLevel);
      }
      
      FactorIndex = FactorIndex + factorNumber;
      Index = Index + 1;
   }

   return(0);
}






double CalculateSquare(double Factor, double Price)
{
   double AnglePrice1a=0;



  if(Price > 0)
   {
   
      if(StringFind(Symbol(),"JPY",0) == -1)
      {
         Price = Price * line_spacing_multiplier;
      }
      else
      {
         Price = Price * line_spacing_multiplier;
         Price = Price  / 100;
      }
            
      if(is_this_the_HIGH_price==false)
      {
         AnglePrice1a = MathPow(MathSqrt(Price) + Factor,2);
      }
      else
      {
         AnglePrice1a = MathPow(MathSqrt(Price) - Factor,2);
      }
   
      if(StringFind(Symbol(),"JPY",0) == -1)
      {
         AnglePrice1a = AnglePrice1a / line_spacing_multiplier;
      }
      else
      {
         AnglePrice1a = AnglePrice1a / line_spacing_multiplier;
         AnglePrice1a = AnglePrice1a  * 100;
      }
   
   }
   
   return(AnglePrice1a);

 
} 